(function (global, factory) {
   typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/core'), require('@angular/common/http'), require('sbxcorejs'), require('@angular/common'), require('ngx-cookie-service')) :
   typeof define === 'function' && define.amd ? define(['exports', 'rxjs', 'rxjs/operators', '@angular/core', '@angular/common/http', 'sbxcorejs', '@angular/common', 'ngx-cookie-service'], factory) :
   (factory((global.sbxangular = {}),global.rxjs,global.rxjs.operators,global.ng.core,global.ng.common.http,global.Find,global.ng.common,global.ngxCookieService));
}(this, (function (exports,rxjs,operators,core,http,sbxcorejs,common,ngxCookieService) { 'use strict';

   var __extends = (undefined && undefined.__extends) || (function () {
       var extendStatics = Object.setPrototypeOf ||
           ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
           function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
       return function (d, b) {
           extendStatics(d, b);
           function __() { this.constructor = d; }
           d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
       };
   })();
   var SbxCoreService = /** @class */ (function (_super) {
       __extends(SbxCoreService, _super);
       function SbxCoreService(httpClient) {
           var _this = _super.call(this) || this;
           _this.httpClient = httpClient;
           return _this;
       }
       SbxCoreService.prototype.initialize = function (domain, appKey, baseUrl) {
           if (baseUrl === void 0) { baseUrl = 'https://sbxcloud.com/api'; }
           _super.prototype.initialize.call(this, domain, appKey, baseUrl);
           this.headers = new http.HttpHeaders()
               .set('App-Key', appKey);
       };
       SbxCoreService.prototype.addHeaderAttr = function (name, value) {
           this.headers = this.getHeaders().set(name, value);
       };
       SbxCoreService.prototype.removeHeaderAttr = function (name) {
           this.headers = this.getHeaders().delete(name);
       };
       SbxCoreService.prototype.getHeaders = function () {
           return this.headers;
       };
       SbxCoreService.prototype.getHeadersJSON = function () {
           return this.getHeaders().append('Content-Type', 'application/json');
       };
       SbxCoreService.prototype.$p = function (path) {
           return sbxcorejs.SbxCore.environment.baseUrl + path;
       };
       /**
        * AUTH
        */
       /**
        * @param {string} token
        */
       SbxCoreService.prototype.validate = function (token) {
           return this.validateRx(token).toPromise();
       };
       /**
        * @param {string} token
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.validateRx = function (token) {
           var httpParams = new http.HttpParams().set('token', token);
           var option = { headers: this.getHeadersJSON(), params: httpParams };
           return this.httpClient.get(this.$p(this.urls.validate), option).pipe(operators.map(function (data) { return data; }));
       };
       /**
        *
        * @param {string} login
        * @param {string} email
        * @param {string} name
        * @param {string} password
        */
       SbxCoreService.prototype.signUp = function (login, email, name, password) {
           return this.signUpRx(login, email, name, password).toPromise();
       };
       /**
        * @param {string} login
        * @param {string} email
        * @param {string} name
        * @param {string} password
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.signUpRx = function (login, email, name, password) {
           if (this.validateLogin(login) && this.validateEmail(email)) {
               var option = { headers: this.getHeadersJSON() };
               var params = '?email=' + this.encodeEmails(email) + '&password=' + encodeURIComponent(password) + '&name='
                   + name + '&login=' + login + '&domain=' + sbxcorejs.SbxCore.environment.domain.toLocaleString();
               return this.httpClient.get(this.$p(this.urls.register) + params, option).pipe(operators.map(function (data) { return data; }));
           }
           else {
               return rxjs.of({ success: false,
                   error: 'Login or email contains invalid characters. Letters, numbers and underscore are accepted' });
           }
       };
       /**
        * @param {string} login
        * @param {string} password
        * @param {Callback} callBack
        * @param {domain}
        */
       SbxCoreService.prototype.login = function (login, password, domain) {
           return this.loginRx(login, password, domain).toPromise();
       };
       /**
        * @param {string} login
        * @param {string} password
        *  @param {domain}
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.loginRx = function (login, password, domain) {
           if ((this.validateLogin(login) && login.indexOf('@') < 0) || (login.indexOf('@') >= 0 && this.validateEmail(login))) {
               var option = { headers: this.getHeadersJSON() };
               var params = '?login=' + this.encodeEmails(login) + '&password=' + encodeURIComponent(password)
                   + (domain ? '&domain=' + domain : '');
               return this.httpClient.get(this.$p(this.urls.login) + params, option).pipe(operators.map(function (data) { return data; }));
           }
           else {
               return rxjs.of({ success: false,
                   error: 'Login contains invalid characters. Letters, numbers and underscore are accepted' });
           }
       };
       /**
        * Send email to changePassword
        * @param {string} userEmail
        * @param {string} subject
        * @param {string} emailTemplate
        */
       SbxCoreService.prototype.sendPasswordRequest = function (userEmail, subject, emailTemplate) {
           return this.sendPasswordRequestRx(userEmail, subject, emailTemplate).toPromise();
       };
       /**
        * Send email to changePassword
        * @param {string} userEmail
        * @param {string} subject
        * @param {string} emailTemplate
        * @return {Observable<Object>}
        */
       SbxCoreService.prototype.sendPasswordRequestRx = function (userEmail, subject, emailTemplate) {
           var body = { user_email: userEmail,
               domain: sbxcorejs.SbxCore.environment.domain, subject: subject, email_template: emailTemplate };
           var option = { headers: this.getHeadersJSON() };
           return this.httpClient.post(this.$p(this.urls.password), body, option).pipe(operators.map(function (data) { return data; }));
       };
       /**
        * change password with email code
        * @param {number} userId
        * @param {number} userCode
        * @param {string} newPassword
        */
       SbxCoreService.prototype.requestChangePassword = function (userId, userCode, newPassword) {
           return this.requestChangePasswordRx(userId, userCode, newPassword).toPromise();
       };
       /**
        * change password with email code
        * @param {number} userId
        * @param {number} userCode
        * @param {string} newPassword
        * @return {Observable<Object>}
        */
       SbxCoreService.prototype.requestChangePasswordRx = function (userId, userCode, newPassword) {
           var body = { domain: sbxcorejs.SbxCore.environment.domain,
               password: newPassword,
               user_id: userId,
               code: userCode };
           var option = { headers: this.getHeadersJSON() };
           return this.httpClient.put(this.$p(this.urls.password), body, option).pipe(operators.map(function (data) { return data; }));
       };
       /**
        * change password
        * @param {string} newPassword
        */
       SbxCoreService.prototype.changePassword = function (newPassword) {
           return this.changePasswordRx(newPassword).toPromise();
       };
       /**
        * change password
        * @param {string} newPassword
        * @return {Observable<Object>}
        */
       SbxCoreService.prototype.changePasswordRx = function (newPassword) {
           var httpParams = new http.HttpParams().set('domain', sbxcorejs.SbxCore.environment.domain).set('password', newPassword);
           var option = { headers: this.getHeadersJSON(), params: httpParams };
           return this.httpClient.get(this.$p(this.urls.update_password), option).pipe(operators.map(function (data) { return data; }));
       };
       /***
        * DATA
        */
       /**
        * @param {string} model the name model in sbxcloud
        * @param data can be a JSON, or TypeScript Class or Array of both
        *  @param letNull let null data
        */
       SbxCoreService.prototype.insert = function (model, data, letNull) {
           return this.insertRx(model, data, letNull).toPromise();
       };
       /**
        * @param {string} model the name model in sbxcloud
        * @param data can be a JSON, or TypeScript Class or Array of both
        * @param letNull let null data
        */
       SbxCoreService.prototype.update = function (model, data, letNull) {
           return this.updateRx(model, data, letNull).toPromise();
       };
       /**
        * @param {string} model the name model in sbxcloud
        * @param data can be a JSON, or TypeScript Class or Array of both
        * @param letNull let null data
        * @return {Observable}
        */
       SbxCoreService.prototype.insertRx = function (model, data, letNull) {
           var body = this.upsert(model, data, letNull);
           var option = { headers: this.getHeadersJSON() };
           return this.httpClient.post(this.$p(this.urls.row), body, option).pipe(operators.map(function (res) { return res; }));
       };
       /**
        * @param {string} model the name model in sbxcloud
        * @param data can be a JSON, or TypeScript Class or Array of both
        * @param letNull let null data
        * @return {Observable}
        */
       SbxCoreService.prototype.updateRx = function (model, data, letNull) {
           var body = this.upsert(model, data, letNull);
           var option = { headers: this.getHeadersJSON() };
           return this.httpClient.post(this.$p(this.urls.update), body, option).pipe(operators.map(function (res) { return res; }));
       };
       /**
        * @param {string} model the name model in sbxcloud
        */
       SbxCoreService.prototype.with = function (model) {
           return new AngularFind(model, this);
       };
       /**
        * @param {EmailData} data
        */
       SbxCoreService.prototype.sendEmail = function (data) {
           return this.sendEmailRx(data).toPromise();
       };
       /**
        * @param {EmailData} data
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.sendEmailRx = function (data) {
           var mail = {
               subject: data.subject,
               to: data.to,
               domain: sbxcorejs.SbxCore.environment.domain,
               from: data.from,
           };
           if (data.template) {
               mail.html = data.template;
           }
           else {
               mail.template_key = data.template_key;
           }
           if (data.cc) {
               mail.cc = data.cc;
           }
           if (data.bcc) {
               mail.bcc = data.bcc;
           }
           if (data.data) {
               mail.data = data.data;
           }
           var option = { headers: this.getHeadersJSON() };
           return this.httpClient.post(this.$p(this.urls.send_mail), mail, option).pipe(operators.map(function (res) { return res; }));
       };
       /**
        * @param data
        */
       SbxCoreService.prototype.paymentCustomer = function (data) {
           return this.paymentCustomerRx(data).toPromise();
       };
       /**
        * @param data
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.paymentCustomerRx = function (data) {
           data['domain'] = sbxcorejs.SbxCore.environment.domain;
           var option = { headers: this.getHeadersJSON() };
           return this.httpClient.post(this.$p(this.urls.payment_customer), data, option).pipe(operators.map(function (res) { return res; }));
       };
       /**
        * @param data
        */
       SbxCoreService.prototype.paymentCard = function (data) {
           return this.paymentCardRx(data).toPromise();
       };
       /**
        * @param data
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.paymentCardRx = function (data) {
           data['domain'] = sbxcorejs.SbxCore.environment.domain;
           var option = { headers: this.getHeadersJSON() };
           return this.httpClient.post(this.$p(this.urls.payment_card), data, option).pipe(operators.map(function (res) { return res; }));
       };
       /**
        * @param {string} key
        * @param file
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.uploadFileRx = function (key, file) {
           var input = new FormData();
           input.append('file', file);
           input.append('model', JSON.stringify({ key: key }));
           var option = { headers: this.getHeaders() };
           return this.httpClient.post(this.$p(this.urls.uploadFile), input, option).pipe(operators.map(function (res) { return res; }));
       };
       /**
        *
        * @param {string} key
        * @param file
        */
       SbxCoreService.prototype.uploadFile = function (key, file) {
           return this.uploadFileRx(key, file).toPromise();
       };
       /**
        * @param {string} key
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.downloadFileRx = function (key) {
           var httpParams = new http.HttpParams().set('action', 'download').set('key', key);
           var option = { headers: this.getHeaders(), params: httpParams };
           return this.httpClient.get(this.$p(this.urls.downloadFile), option).pipe(operators.map(function (res) { return res; }));
       };
       /**
        *
        * @param {string} key
        */
       SbxCoreService.prototype.downloadFile = function (key) {
           return this.downloadFileRx(key).toPromise();
       };
       /**
        * CLOUDSCRIPT
        */
       /**
        *
        * @param {string} key
        * @param params
        * @return {Observable<any>}
        */
       SbxCoreService.prototype.runRx = function (key, params) {
           var option = { headers: this.getHeadersJSON() };
           return this.httpClient.post(this.$p(this.urls.cloudscript_run), { key: key, params: params }, option).pipe(operators.map(function (res) { return res; }));
       };
       /**
        * @param {string} key
        * @param params
        */
       SbxCoreService.prototype.run = function (key, params) {
           return this.runRx(key, params).toPromise();
       };
       SbxCoreService.decorators = [
           { type: core.Injectable },
       ];
       /** @nocollapse */
       SbxCoreService.ctorParameters = function () { return [
           { type: http.HttpClient }
       ]; };
       return SbxCoreService;
   }(sbxcorejs.SbxCore));
   var SbxResponse = /** @class */ (function () {
       function SbxResponse() {
       }
       SbxResponse.prototype.isAny = function () {
           return this.results === undefined
               || this.results === null
               || this.results.length === 0
               || this.results[0].constructor.name === 'Object';
       };
       SbxResponse.prototype.toAny = function () {
           return this;
       };
       return SbxResponse;
   }());
   var AngularFind = /** @class */ (function (_super) {
       __extends(AngularFind, _super);
       function AngularFind(model, core$$1) {
           var _this = _super.call(this, model, sbxcorejs.SbxCore.environment.domain) || this;
           _this.core = core$$1;
           _this.totalpages = 1;
           return _this;
       }
       AngularFind.prototype.delete = function () {
           return this.deleteRx().toPromise();
       };
       AngularFind.prototype.deleteRx = function () {
           this.setUrl(false);
           return this.thenRx();
       };
       /**
       * @param {Array} toFetch Optional params to auto map fetches result.
       * match T object, no return fetched_results
        */
       AngularFind.prototype.find = function (toFetch) {
           if (toFetch === void 0) { toFetch = []; }
           return this.findRx(toFetch).toPromise();
       };
       /**
        * @param {Array} toFetch Optional params to auto map fetches result.
        * match T object, no return fetched_results
        */
       AngularFind.prototype.findRx = function (toFetch) {
           if (toFetch === void 0) { toFetch = []; }
           this.setUrl(true);
           return this.thenRx(toFetch);
       };
       /**
      * @param {Array} toFetch Optional params to auto map fetches result.
      */
       AngularFind.prototype.loadAll = function (toFetch) {
           if (toFetch === void 0) { toFetch = []; }
           return this.loadAllRx(toFetch).toPromise();
       };
       /**
      * @param {Array} toFetch Optional params to auto map fetches result.
      */
       AngularFind.prototype.loadAllRx = function (toFetch) {
           var _this = this;
           if (toFetch === void 0) { toFetch = []; }
           this.setPageSize(100);
           var query = this.query.compile();
           return this.thenRx().pipe(operators.mergeMap(function (response) {
               _this.totalpages = response.total_pages;
               var i = 2;
               var temp = [rxjs.of(response)];
               while (i <= _this.totalpages) {
                   var queryAux = JSON.parse(JSON.stringify(query));
                   queryAux.page = i;
                   temp.push(_this.findPage(queryAux));
                   i = i + 1;
               }
               return rxjs.merge(temp).pipe(operators.mergeAll(5), operators.toArray());
           }), operators.map(function (res) { return res; }), operators.map(function (results) {
               var result = [];
               var fetched_results = {};
               results.forEach(function (array) {
                   var v = array;
                   result = result.concat(v.results);
                   if (v.fetched_results) {
                       var objs = Object.keys(v.fetched_results);
                       for (var i = 0; i < objs.length; i++) {
                           var type_name = objs[i];
                           if (!fetched_results.hasOwnProperty(type_name)) {
                               fetched_results[type_name] = {};
                           }
                           var keys = Object.keys(v.fetched_results[type_name]);
                           for (var j = 0; j < keys.length; j++) {
                               var key = keys[j];
                               if (v.fetched_results[type_name].hasOwnProperty(key)) {
                                   fetched_results[type_name][key] = v.fetched_results[type_name][key];
                               }
                           }
                       }
                       if (toFetch.length) {
                           result = _this.core.mapFetchesResult(result, toFetch);
                       }
                   }
               });
               return { success: true, results: result, fetched_results: fetched_results };
           }));
       };
       /**
        * Change the url, to find or to delete
        * @param isFind if true, the url is gotten from urls.find else urls.delete
        */
       AngularFind.prototype.setUrl = function (isFind) {
           this.url = isFind ? this.core.$p(this.core.urls.find) : this.core.$p(this.core.urls.delete);
       };
       /**
        * get the data
        * @param {any[]} toFetch Optional params to auto map fetches result.
        * @return {Observable<any>}
        */
       AngularFind.prototype.thenRx = function (toFetch) {
           var _this = this;
           if (toFetch === void 0) { toFetch = []; }
           var option = { headers: this.core.getHeadersJSON() };
           return this.core.httpClient.post(this.url, this.query.compile(), option).pipe(operators.map(function (res) {
               if (res instanceof SbxResponse && res.isAny()) {
                   var newRest = res.toAny();
                   if (toFetch.length && _this.isFind) {
                       return _this.core.mapFetchesResult(newRest, toFetch);
                   }
                   return newRest;
               }
               else {
                   if (res instanceof SbxResponse) {
                       if (!res.success) {
                           throw new Error(res.message);
                       }
                       else {
                           return res.results;
                       }
                   }
                   else {
                       return res;
                   }
               }
           }));
       };
       /**
        * Is used to paginate load all
        * @param query
        * @return {Observable<any>}
        */
       AngularFind.prototype.findPage = function (query) {
           var option = { headers: this.core.getHeadersJSON() };
           return this.core.httpClient.post(this.core.$p(this.core.urls.find), (query == null) ? this.query.compile() : query, option).pipe(operators.map(function (res) { return res; }));
       };
       return AngularFind;
   }(sbxcorejs.Find));

   var SbxInterceptor = /** @class */ (function () {
       function SbxInterceptor() {
       }
       SbxInterceptor.prototype.intercept = function (req, next) {
           // const authReq = req.clone({
           //   headers: req.headers.set('Accept-Encoding', 'gzip')
           // });
           return next.handle(req);
       };
       SbxInterceptor.decorators = [
           { type: core.Injectable },
       ];
       return SbxInterceptor;
   }());

   var SbxCoreModule = /** @class */ (function () {
       function SbxCoreModule() {
       }
       SbxCoreModule.decorators = [
           { type: core.NgModule, args: [{
                       imports: [
                           common.CommonModule,
                           http.HttpClientModule,
                       ],
                       declarations: [],
                       providers: [{
                               provide: http.HTTP_INTERCEPTORS,
                               useClass: SbxInterceptor,
                               multi: true
                           }, SbxCoreService]
                   },] },
       ];
       return SbxCoreModule;
   }());

   var SbxSessionService = /** @class */ (function () {
       function SbxSessionService(sbxCoreService, cookieService) {
           this.sbxCoreService = sbxCoreService;
           this.cookieService = cookieService;
           this.daysToExpire = 30;
           this.cookieToken = 'token';
       }
       SbxSessionService.prototype.initialize = function (domain, appKey) {
           this.sbxCoreService.initialize(domain, appKey);
           this.islogged();
       };
       /**
        * Initialize service with environment
        * @param environment (domain, base_url, appkey)
        */
       SbxSessionService.prototype.initializeWithEnvironment = function (environment) {
           this.sbxCoreService.initialize(environment.domain, environment.appKey, environment.baseUrl);
           this.islogged();
       };
       /**
        * General User methods
        */
       SbxSessionService.prototype.getCurrentUser = function () {
           return (this._user == null) ? this._user = new User() : this._user;
       };
       SbxSessionService.prototype.islogged = function () {
           this.loadCookieToken();
           if (this.getCurrentUser().token != null) {
               this.sbxCoreService.addHeaderAttr('Authorization', 'Bearer ' + this.getCurrentUser().token);
               return true;
           }
           else {
               return false;
           }
       };
       /**
        * methods that uses cookies
        */
       SbxSessionService.prototype.loadCookieToken = function () {
           this.getCurrentUser().token = this.cookieService.check(this.cookieToken) ? this.cookieService.get(this.cookieToken) : null;
       };
       SbxSessionService.prototype.updateCookieToken = function (token) {
           var today = new Date().getTime();
           this.cookieService.set(this.cookieToken, token, new Date(today + this.daysToExpire * SbxSessionService.day));
       };
       SbxSessionService.prototype.updateUser = function (data) {
           this.getCurrentUser().token = data.token;
           this.getCurrentUser().id = data.user.id;
           this.getCurrentUser().name = data.user.name;
           this.getCurrentUser().login = data.user.login;
           this.getCurrentUser().email = data.user.email;
           this.sbxCoreService.addHeaderAttr('Authorization', 'Bearer ' + data.token);
       };
       /**
        * Auth user methods
        */
       SbxSessionService.prototype.login = function (login, password, domain) {
           return this.loginRx(login, password, domain).toPromise();
       };
       SbxSessionService.prototype.loginRx = function (login, password, domain) {
           var _this = this;
           return this.sbxCoreService.loginRx(login, password, domain).pipe(operators.map(function (data) {
               if (data.success) {
                   _this.updateUser(data);
               }
               return data;
           }));
       };
       SbxSessionService.prototype.validate = function (token) {
           this.validateRx(token).toPromise();
       };
       SbxSessionService.prototype.validateRx = function (token) {
           var _this = this;
           return this.sbxCoreService.validateRx(token).pipe(operators.map(function (data) {
               if (data.success) {
                   data.token = token;
                   _this.updateUser(data);
               }
               return data;
           }));
       };
       SbxSessionService.prototype.logout = function () {
           this.cookieService.delete(this.cookieToken);
           this.sbxCoreService.removeHeaderAttr('Authorization');
           this._user = null;
       };
       SbxSessionService.prototype.signUp = function (login, email, name, password) {
           return this.signUpRx(login, email, name, password).toPromise();
       };
       SbxSessionService.prototype.signUpRx = function (login, email, name, password) {
           var _this = this;
           return this.sbxCoreService.signUpRx(login, email, name, password).pipe(operators.map(function (data) {
               if (data.success) {
                   _this.updateUser(data);
               }
               return data;
           }));
       };
       SbxSessionService.day = 86400000;
       SbxSessionService.decorators = [
           { type: core.Injectable },
       ];
       /** @nocollapse */
       SbxSessionService.ctorParameters = function () { return [
           { type: SbxCoreService },
           { type: ngxCookieService.CookieService }
       ]; };
       return SbxSessionService;
   }());
   var User = /** @class */ (function () {
       function User() {
       }
       Object.defineProperty(User.prototype, "name", {
           get: function () {
               return this._name;
           },
           set: function (value) {
               this._name = value;
           },
           enumerable: true,
           configurable: true
       });
       Object.defineProperty(User.prototype, "token", {
           get: function () {
               return this._token;
           },
           set: function (value) {
               this._token = value;
           },
           enumerable: true,
           configurable: true
       });
       Object.defineProperty(User.prototype, "id", {
           get: function () {
               return this._id;
           },
           set: function (value) {
               this._id = value;
           },
           enumerable: true,
           configurable: true
       });
       Object.defineProperty(User.prototype, "email", {
           get: function () {
               return this._email;
           },
           set: function (value) {
               this._email = value;
           },
           enumerable: true,
           configurable: true
       });
       Object.defineProperty(User.prototype, "login", {
           get: function () {
               return this._login;
           },
           set: function (value) {
               this._login = value;
           },
           enumerable: true,
           configurable: true
       });
       return User;
   }());

   var SbxSessionModule = /** @class */ (function () {
       function SbxSessionModule() {
       }
       SbxSessionModule.decorators = [
           { type: core.NgModule, args: [{
                       imports: [
                           common.CommonModule,
                           SbxCoreModule
                       ],
                       declarations: [],
                       providers: [SbxSessionService, ngxCookieService.CookieService]
                   },] },
       ];
       return SbxSessionModule;
   }());

   exports.SbxCoreModule = SbxCoreModule;
   exports.SbxSessionModule = SbxSessionModule;
   exports.SbxCoreService = SbxCoreService;
   exports.SbxSessionService = SbxSessionService;

   Object.defineProperty(exports, '__esModule', { value: true });

})));
