import { SbxCoreService } from '../sbxcore.service';
import { CookieService } from 'ngx-cookie-service';
import { Observable } from 'rxjs';
export declare class SbxSessionService {
    private sbxCoreService;
    private cookieService;
    constructor(sbxCoreService: SbxCoreService, cookieService: CookieService);
    private static day;
    private daysToExpire;
    private cookieToken;
    private _user;
    initialize(domain: number, appKey: string): void;
    /**
     * Initialize service with environment
     * @param environment (domain, base_url, appkey)
     */
    initializeWithEnvironment(environment: any): void;
    /**
     * General User methods
     */
    getCurrentUser(): User;
    islogged(): boolean;
    /**
     * methods that uses cookies
     */
    private loadCookieToken();
    updateCookieToken(token: string): void;
    private updateUser(data);
    /**
     * Auth user methods
     */
    login(login: string, password: string, domain?: number): Promise<any>;
    loginRx(login: string, password: string, domain?: number): Observable<any>;
    validate(token: string): void;
    validateRx(token: string): Observable<any>;
    logout(): void;
    signUp(login: string, email: string, name: string, password: string): Promise<any>;
    signUpRx(login: string, email: string, name: string, password: string): Observable<any>;
}
export declare class User {
    constructor();
    private _name;
    private _login;
    private _token;
    private _id;
    private _email;
    name: string;
    token: string;
    id: number;
    email: string;
    login: string;
}
